VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsCommHandler"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'RemotePRO - emulate IR remote controls using "simplest" IR circuit
'See circuit at http://www.geocities.com/odednoam for circuit
'Copyright (C) 2002 Oded Noam
'
'This program is free software; you can redistribute it and/or
'modify it under the terms of the GNU General Public License
'as published by the Free Software Foundation; either version 2
'of the License, or (at your option) any later version.
'
'This program is distributed in the hope that it will be useful,
'but WITHOUT ANY WARRANTY; without even the implied warranty of
'MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'GNU General Public License for more details.
'
'You should have received a copy of the GNU General Public License
'along with this program; if not, write to the Free Software
'Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
Option Explicit

'''''''''''''''''''''''''''''''''''''''''''''''''''
' clsCommPort: Interface to Windows CommPorts
'''''''''''''''''''''''''''''''''''''''''''''''''''
Private Type OVERLAPPED
    Internal As Long
    InternalHigh As Long
    Offset As Long
    OffsetHigh As Long
    hEvent As Long
End Type

Private Type SECURITY_ATTRIBUTES
    nLength As Long
    lpSecurityDescriptor As Long
    bInheritHandle As Long
End Type

Private Type DCB
    DCBlength As Long       ' 4
    BaudRate As Long        ' 8
    fBinary As Long         '12
    fParity As Long         '16
    fOutxCtsFlow As Long    '20
    fOutxDsrFlow As Long    '24
    fDtrControl As Long     '28
    fDsrSensitivity As Long
    fTXContinueOnXoff As Long
    fOutX As Long
    fInX As Long
    fErrorChar As Long
    fNull As Long
    fRtsControl As Long
    fAbortOnError As Long
    fDummy2 As Long
    wReserved As Long
    XonLim As Long
    XoffLim As Long
    
    ByteSize As Integer
    PARITY As Integer
    STOPBITS As Integer
    XonChar As String * 1
    XoffChar As String * 1
    ErrorChar As String * 1
    EofChar As String * 1
    EvtChar As String * 1
End Type

Private Type COMMTIMEOUTS
    ReadIntervalTimeout As Long
    ReadTotalTimeoutMultiplier As Long
    ReadTotalTimeoutConstant As Long
    WriteTotalTimeoutMultiplier As Long
    WriteTotalTimeoutConstant As Long
End Type

Private Type COMMPROP
    wPacketLength As Integer
    wPacketVersion As Integer
    dwServiceMask As Long
    dwReserved1 As Long
    dwMaxTxQueue As Long
    dwMaxRxQueue As Long
    dwMaxBaud As Long
    dwProvSubType As Long
    dwProvCapabilities As Long
    dwSettableParams As Long
    dwSettableBaud As Long
    wSettableData As Integer
    wSettableStopParity As Integer
    dwCurrentTxQueue As Long
    dwCurrentRxQueue As Long
    dwProvSpec1 As Long
    dwProvSpec2 As Long
    wcProvChar(1) As Integer
End Type

' The eight actual COMSTAT bit-sized data fields within the four bytes of fBitFields can be manipulated by bitwise logical And/Or operations.
' FieldName     Bit #     Description
' ---------     -----     ---------------------------
' fCtsHold        1       Tx waiting for CTS signal
' fDsrHold        2       Tx waiting for DSR signal
' fRlsdHold       3       Tx waiting for RLSD signal
' fXoffHold       4       Tx waiting, XOFF char rec'd
' fXoffSent       5       Tx waiting, XOFF char sent
' fEof            6       EOF character sent
' fTxim           7       character waiting for Tx
' fReserved       8       reserved (25 bits)
Private Type COMSTAT
    fBitFields As Long 'See Comment
    cbInQue As Long
    cbOutQue As Long
End Type

Private Type COMMCONFIG
    dwSize As Long
    wVersion As Integer
    wReserved As Integer
    dcbx As DCB
    dwProviderSubType As Long
    dwProviderOffset As Long
    dwProviderSize As Long
    wcProviderData As Byte
End Type
    
Private Const GENERIC_READ = &H80000000
Private Const GENERIC_WRITE = &H40000000
Private Const FILE_SHARE_READ = &H1
Private Const FILE_SHARE_WRITE = &H2
Private Const FILE_FLAG_OVERLAPPED = &H40000000
Private Const OPEN_EXISTING = 3
Private Const MS_CTS_ON = &H10&
Private Const MS_DSR_ON = &H20&
Private Const MS_RING_ON = &H40&
Private Const MS_RLSD_ON = &H80&
Private Const INFINITE = &HFFFF      '  Infinite timeout
Private Const ERROR_IO_PENDING = 997 '  dderror
Public Enum PARITY
    PARITY_NO = 0
    PARITY_ODD = 1
    PARITY_EVEN = 2
    PARITY_MARK = 3
    PARITY_SPACE = 4
End Enum
Public Enum STOPBITS
    STOP_1 = 0
    STOP_1_5 = 1
    STOP_2 = 2
End Enum
Private Declare Function CloseHandle Lib "kernel32" _
    (ByVal hObject As Long) As Long
Private Declare Function CreateFile Lib "kernel32" Alias "CreateFileA" _
    (ByVal lpFileName As String, ByVal dwDesiredAccess As Long, ByVal dwShareMode As Long, lpSecurityAttributes As SECURITY_ATTRIBUTES, ByVal dwCreationDisposition As Long, ByVal dwFlagsAndAttributes As Long, ByVal hTemplateFile As Long) As Long
    
Private Declare Function GetCommState Lib "kernel32" _
    (ByVal hFile As Long, lpDCB As DCB) As Long
Private Declare Function SetCommState Lib "kernel32" _
    (ByVal hFile As Long, lpDCB As DCB) As Long

Private Declare Function SetupComm Lib "kernel32" _
    (ByVal hFile As Long, ByVal dwInQueue As Long, ByVal dwOutQueue As Long) As Long
Private Declare Function PurgeComm Lib "kernel32" _
    (ByVal hFile As Long, ByVal dwFlags As Long) As Long
Private Declare Function CreateEvent Lib "kernel32" Alias "CreateEventA" _
    (lpEventAttributes As SECURITY_ATTRIBUTES, ByVal bManualReset As Long, ByVal bInitialState As Long, ByVal lpName As String) As Long
Private Declare Function GetCommTimeouts Lib "kernel32" _
    (ByVal hFile As Long, lpCommTimeouts As COMMTIMEOUTS) As Long
Private Declare Function SetCommTimeouts Lib "kernel32" _
    (ByVal hFile As Long, lpCommTimeouts As COMMTIMEOUTS) As Long
Private Declare Function GetCommProperties Lib "kernel32" _
    (ByVal hFile As Long, lpCommProp As COMMPROP) As Long
Private Declare Function ReadFile Lib "kernel32" _
    (ByVal hFile As Long, lpBuffer As Any, ByVal nNumberOfBytesToRead As Long, lpNumberOfBytesRead As Long, ByVal lpOverlapped As Long) As Long
Private Declare Function WriteFile Lib "kernel32" _
    (ByVal hFile As Long, lpBuffer As String, ByVal nNumberOfBytesToWrite As Long, lpNumberOfBytesWritten As Long, ByVal lpOverlapped As Long) As Long
Private Declare Function TransmitCommChar Lib "kernel32" _
    (ByVal nCid As Long, ByVal cChar As Long) As Long
Private Declare Function ClearCommBreak Lib "kernel32" _
    (ByVal nCid As Long) As Long
Private Declare Function SetCommBreak Lib "kernel32" _
    (ByVal nCid As Long) As Long
Private Declare Function ClearCommError Lib "kernel32" _
    (ByVal hFile As Long, lpErrors As Long, lpStat As COMSTAT) As Long
Private Declare Function EscapeCommFunction Lib "kernel32" _
    (ByVal nCid As Long, ByVal nFunc As Long) As Long
Private Declare Function GetCommModemStatus Lib "kernel32" _
    (ByVal hFile As Long, lpModemStat As Long) As Long
Private Declare Function GetCommConfig Lib "kernel32" _
    (ByVal hCommDev As Long, lpCommConfig As COMMCONFIG, lpdwSize As Long) As Long
Private Declare Function SetCommConfig Lib "kernel32" _
    (ByVal hCommDev As Long, lpCC As COMMCONFIG, ByVal dwSize As Long) As Long
Private Declare Function GetCommMask Lib "kernel32" _
    (ByVal hFile As Long, lpEvtMask As Long) As Long
Private Declare Function SetCommMask Lib "kernel32" _
    (ByVal hFile As Long, ByVal dwEvtMask As Long) As Long
Private Declare Function WaitCommEvent Lib "kernel32" _
    (ByVal hFile As Long, lpEvtMask As Long, lpOverlapped As OVERLAPPED) As Long
Private Declare Function ResetEvent Lib "kernel32" _
    (ByVal hEvent As Long) As Long
Private Declare Function GetLastError Lib "kernel32" () As Long
Private Declare Function WaitForSingleObject Lib "kernel32" _
    (ByVal hHandle As Long, ByVal dwMilliseconds As Long) As Long
Private Declare Function GetOverlappedResult Lib "kernel32" (ByVal hFile As Long, lpOverlapped As OVERLAPPED, lpNumberOfBytesTransferred As Long, ByVal bWait As Long) As Long
'''''''''''''''''''''''''''''''''''''''''''''''''''
Private m_bFileOpened As Boolean
Private m_hFile As Long

Private Sub Class_Initialize()
    m_bFileOpened = False
    m_hFile = 0
End Sub

Public Function OpenPort(ByVal iCommNumber As Integer) As Boolean
    Dim iLastErr As Integer
    
    OpenPort = True
    If (m_bFileOpened) Then
        OpenPort = False
        Exit Function
    End If
    
    Dim sa As SECURITY_ATTRIBUTES
    sa.bInheritHandle = False
    sa.lpSecurityDescriptor = 0
    sa.nLength = Len(sa)
    
    m_hFile = CreateFile("COM" & iCommNumber & ":", _
                         GENERIC_READ Or GENERIC_WRITE, _
                         0, _
                         sa, _
                         OPEN_EXISTING, _
                         0, _
                         0)
    If m_hFile <= 0 Then
        OpenPort = False
        Exit Function
    End If
    
    Dim ctTimeout As COMMTIMEOUTS
    ctTimeout.ReadIntervalTimeout = 1
    ctTimeout.ReadTotalTimeoutConstant = 1
    ctTimeout.ReadTotalTimeoutMultiplier = 1
    ctTimeout.WriteTotalTimeoutConstant = 5000
    ctTimeout.WriteTotalTimeoutMultiplier = 6000
    Call SetCommTimeouts(m_hFile, ctTimeout)
    

End Function

Function ClosePort() As Boolean
    ClosePort = True
    If (m_hFile > 0) Then
        CloseHandle (m_hFile)
        m_hFile = 0
    End If
End Function

Private Sub Class_Terminate()
    ClosePort
End Sub

Public Sub CommRead(out_strData As String)
    Dim strChar As String * 1
    CommWrite ("at" & vbCrLf)
    out_strData = ""
    If ReadOneChar(strChar) Then
        out_strData = out_strData & strChar
    End If
    
End Sub


Public Function CommReadChar() As String
    Dim strChar As String * 2
    If ReadOneChar(strChar) Then
        CommReadChar = Left(strChar, 1)
    End If
    
End Function

Private Function ReadOneChar(out_strChar As String) As Boolean
    Dim rc As Long
    Dim lActualLength As Long
    rc = ReadFile(m_hFile, ByVal out_strChar, 1, lActualLength, 0) 'm_stOLRead.stOverlapped)
    Debug.Print "ReadFile rc " & rc
    If (lActualLength = 1) Then ReadOneChar = True Else ReadOneChar = False
End Function

Public Sub CommWrite(ByVal in_strData As String)
    Dim rc As Long
    Dim lActualLength As Long
    rc = WriteFile(m_hFile, ByVal in_strData, Len(in_strData), lActualLength, 0)
    Debug.Print "WriteFile rc " & rc & " (Last error " & GetLastError() & ")"
    If (lActualLength <> Len(in_strData)) Then
         MsgBox "Write error"
    End If
End Sub
Public Function GetCommStatus() As String
    
    Dim lModemStatus As Long
    Dim strModemStatus As String
    
    Dim dcbModemState As DCB
    dcbModemState.DCBlength = Len(dcbModemState)
    
    If GetCommState(m_hFile, dcbModemState) Then
        strModemStatus = dcbModemState.BaudRate & "," & _
            dcbModemState.PARITY & "," & _
            dcbModemState.ByteSize & "," & _
            dcbModemState.STOPBITS
    Else
        strModemStatus = "Cannot get Comm State. "
    End If
    
    If GetCommModemStatus(m_hFile, lModemStatus) Then
        If (lModemStatus And MS_CTS_ON) Then strModemStatus = strModemStatus & " CTS"
        If (lModemStatus And MS_DSR_ON) Then strModemStatus = strModemStatus & " DSR"
        If (lModemStatus And MS_RING_ON) Then strModemStatus = strModemStatus & " RING"
        If (lModemStatus And MS_RLSD_ON) Then strModemStatus = strModemStatus & " RLSD"
    Else
        strModemStatus = strModemStatus & "Cannot get Comm Status."
    End If
    
    GetCommStatus = strModemStatus

End Function

Public Function SetState(ByVal in_nBaud As Long, _
                         ByVal in_eParity As PARITY, _
                         ByVal in_nBits As Integer, _
                         ByVal in_eStopBit As STOPBITS) As Boolean
    Dim rc As Integer
    Dim dcbModemState As DCB
    rc = GetCommState(m_hFile, dcbModemState)
    dcbModemState.DCBlength = Len(dcbModemState)
    dcbModemState.BaudRate = in_nBaud
    dcbModemState.fBinary = 1
    dcbModemState.fParity = 1
    dcbModemState.fOutxDsrFlow = 0          '  DSR output flow control
    dcbModemState.fDtrControl = 0           '  DTR flow control type
    dcbModemState.fDsrSensitivity = 0       '  DSR sensitivity
    dcbModemState.fTXContinueOnXoff = 0     '  XOFF continues Tx
    dcbModemState.fOutX = 1                 '  XON/XOFF output flow control
    dcbModemState.fInX = 1                  '  XON/XOFF input flow control
    dcbModemState.fErrorChar = 0            '  enable error replacement
    dcbModemState.fNull = 0                 '  enable null stripping
    dcbModemState.fRtsControl = 0           '  RTS flow control
    dcbModemState.fAbortOnError = 0         '  abort reads/writes on error
    dcbModemState.XonLim = 2048             '  transmit XON threshold
    dcbModemState.XoffLim = 512             '  transmit XOFF threshold
    dcbModemState.ByteSize = in_nBits       '  number of bits/byte, 4-8
    dcbModemState.PARITY = in_eParity       '  0-4=no,odd,even,mark,space
    dcbModemState.STOPBITS = in_eStopBit    '  0,1,2 = 1, 1.5, 2
    dcbModemState.XonChar = Chr(17)         '  Tx and Rx XON character
    dcbModemState.XoffChar = Chr(19)        '  Tx and Rx XOFF character
    dcbModemState.ErrorChar = Chr(0)        '  error replacement character
    dcbModemState.EofChar = Chr(0)          '  end of input character
    dcbModemState.EvtChar = Chr(0)
    
    rc = SetCommState(m_hFile, dcbModemState)
    Debug.Print "SetState returning " & rc & " (lasterror " & GetLastError() & ")"
    SetState = (rc <> 0)
    
End Function

